%In this program we carry out the calculations for example 7.2, the eignevalues for the infinite buffer case. 
function x=ex72(Cp,N,a,b,R)
%Cp=channel capacity, N=number of binary sources, a=flow to active stat,
%b=flow to idle state and R=rate of single source in the active state.
%Recall that R cannot be such that C-iR=0 for i=1,2,...,N.

%Now check the load with respect to capacity.
load=N*R*a/(a+b)
if load >= Cp%Indicates overload and there is no point in going further. 
    return
end  
%steady-state probabilities
for i=0:N
    p(i+1)=comb(N,i)*(a/(a+b))^i*(b/(a+b))^(N-i);
end

for k=0:fix(N/2);% As mentionned in the text, the terms A, B and C are symmetric about N/2.
    
    A(k+1)=(R*(k-N/2))^2-(Cp-R*N/2)^2; %Start with equation (7.33).
    B(k+1)=2*R*(b-a)*(k-N/2)^2+N*(a+b)*(Cp-R*N/2);
    C(k+1)=((a+b)^2)*((k-N/2)^2-(N/2)^2);
    
end
    
 for kk =0:fix(N/2)
    e(kk+1)=(-B(kk+1)-sqrt(B(kk+1)^2-4*A(kk+1)*C(kk+1)))/(2*A(kk+1)); %First of pair of eigenvalues.
    e(N-kk+1)=(-B(kk+1)+sqrt(B(kk+1)^2-4*A(kk+1)*C(kk+1)))/(2*A(kk+1));%Second
end
%When N is even, the eignvalue for k=N/2 is computed two, but the coding is simplied. 
    
nopos = fix(Cp/R);%As a check we should have this many positive roots as well as a root at 0.
x=e;