%We do calculations for Example 8.1. This is just the calculation of D0,
% and D1.
% The inputs are: 
% R a (LxL) matrix, element r(i,j)= tranition rate from i to j 
% Give the input as [0, r12, r13...,r21,0,r22,r23...,r31,r32,0,r34...,....]
% For example for the tutorial case, we can give R as, [0 1;2 0]
% LMBD a a L dimansional vector giving the rates for each phase.
% Give lambda as a row [lambda1 lambda2 lambda3 ....]
% For the tutorial case, we can give LMBD as [10 5]

function DMAT=ex81(R,LMBD)
%We repeat the calculations of ex84.
L=size(R,1);%The number of phases
%The first step is to find the matrix D, as in equation (8.8).
D0=R;%Initializationzzz=ex82(R)

for i = 1:L
    D0(i,i)=-sum(R(i,:))-LMBD(i);%The diagonal elements are to sums of off diagonal elements;
end

D1=zeros(L);
for i=1:L
    D1(i,i)=LMBD(i);
end
DMAT=D0 %D0 is the first page of a three dimensional array.
DMAT(:,:,2)=D1 %D1 is the second page.