%The is the program for generating a probability histogram 
%for a binomial distribution.The inputs are the 
%parameters for the binomial distribution, n and p
%and smplsz which is the number of samples.

function [dist]= ex912bin(n,p,smplsz)

dist(1)=(1-p)^n;%zero trm of the binomial distribution

for i=1:n %calculating the binomial distribution
   dist(i+1)=dist(i)*((n-i+1)/i)*(p/(1-p));
end

%Now generate sample from the binomial distribution and
%compile the histogram. 

for i=1:length(dist)%initiallizing the histogram
   h(i)=0;
end

for i=1:smplsz
   sum=0;%initializing
   ind=0;%initializing
   u=rand;%generatin a U(0,1) RV
   
   while sum<u%stepping through the distribution
      ind=ind+1;
      sum=sum+dist(ind);
   end
   
   %ind is the value of the sample
   h(ind)=h(ind)+1;%compiling the histogram
end

for i=1:length(dist)
   h(i)=h(i)/smplsz;%Normalizing the histogram
end

