%The program for generating a probability histogram 
%for a geometric distribution.The inputs are the 
%the probability of success on  a trial
%and smplsz which is the number of samples.

function [h]= ex912geo(p,smplsz)

max=fix((1-p)/p)+10*fix((1-p)/p^2)%initializing the maximum 
%value of the sample
h=zeros(1,max);%initiallizing the histogram at max length


%Now generate samples from the geometric distribution 
%and compile the histogram. 
for i=1:smplsz  
   
   dist=p;%zero term of the geometric distribution
   sum=dist;%initializing
   ind=1;%initializing    
   u=rand;%generatin a U(0,1) RV
   
   while sum<u & ind<max %stepping through the distribution
      ind=ind+1;
      dist=dist*(1-p);
      sum=sum+dist;
   end
   
   %ind is the value of the sample
   h(ind)=h(ind)+1;%compiling the histogram
end 

for i=1:max
   h(i)=h(i)/smplsz;%Normalizing the histogram
end

