%The program for generating a probability histogram 
%for a binomial distribution by summing Bernoulli RVs.
%The inputs are the parameters for the binomial 
%distribution, n and p and smplsz which is the number 
%of samples.

function [h]= ex913bin(n,p,smplsz)

h=zeros(1,n+1);%initiallizing the histogram

for i=1:smplsz 
   sum=0;%initializing
      for j=1:n
      if(rand<p);%generating a Bernoulli RV
         sum=sum+1;
      end
      end
   ind=sum+1;%binomial RV
   h(ind)=h(ind)+1;%compiling the histogram
end

for i=1:n+1
   h(i)=h(i)/smplsz;%Normalizing the histogram
end

