%The program for generating a probability histogram 
%for a Poisson distribution. A sequence of exponential
%random variables are multiplied together until a threshld 
%is passed.
function [h]= ex913pois(l,t,smplsz)

max=fix(1/l)+20*(fix(1/l)+1)%the maximum value of the sample
h=zeros(1,max);%initiallizing the histogram at max length


%Now generate samples from the Poisson distribution 
%and compile the histogram. 
for i=1:smplsz  
   prod=rand;
   thresh=exp(-l*t);
   ind=0;%initializing       
   while thresh < prod & ind+1<max %stepping through the distribution
      ind=ind+1;
      prod=prod*rand;
   end
   
   %ind is the value of the sample
   h(ind+1)=h(ind+1)+1;%compiling the histogram
end 

for i=1:max
   h(i)=h(i)/smplsz;%Normalizing the histogram
end

