%Compliling a histogram for an exponentially distributed
%random variable
%cells is the number of cells and trials is the 
%number of samples.
function [h]=ex98(cells,trials)
%Initiallizing the histogram
for i=1:cells
   h(i)=0;
end
%Generating exponential random varibles with mean 10
%and placeing them in cells
for i=1:trials
   re=-10*log(1-rand);%Generating exponetially 
   %distributed random variables.
   %The factor of 10 specifies the mean value.
   if re >= 100 % Tail beyond 100 is negligable
      k=cells;
   else k=fix(re/(100/cells))+1;%finding the cell to be 
      %incremented
   end
   h(k)=h(k)+1; 
end
x=0:1:99;
bar(x,h);
axis([0 cells 0 trials/10]); % Note-> you may have to change the y axis limits
%depending on your samples range....
hold
e = cexp(10);
e = e*trials;
plot(x,e,'-r');
%for k=1:100
%   h(k)=h(k)/trials;
%end
return
