%Here we are evaluating Equations 8.86 and 8.87

function [Wvp1e,Wvp2e] = ex811(R,LMBD,m)

%We get D0 and D1 from example 8.1.
fetch = ex81(R,LMBD);
D0=fetch(:,:,1);
D1=fetch(:,:,2);
D = D0 + D1; 
 I = [ 1 0; 0 1];
L=size(R,1);

[P0 pi alphaint G] =ex86(R,LMBD,m);

avelmbd=pi*D1*ones(L,1);
rho=avelmbd*m;
et = [1;1];

[P0hat P1hat P2hat] = ex89(R,LMBD,m);

V1p = -m*D1;
V2p = m^2*D1;
V3p = -m^3*D1;

MV1p = -(  (1/(2*(1-rho)))  * (  (pi*D1*m) + ( (P0hat - (pi*V1p)) * ((et*pi)+D)^(-1) * V1p ) + (pi * V2p)  )  );
MV2p = (1/(3*(1-rho)))  * (  (   (  (2*MV1p) + (2*MV1p*V1p) + (pi*V2p)  ) *  ((et*pi)+D)^(-1) * V1p   ) - (3*MV1p*V2p) - (pi*V3p)  );

Wvp1e=MV1p*et;
Wvp2e=MV2p*et;

return