%In this example, we are evaluting Equations (8.76) and (8.77) 
%The inputs are: 
% R a (LxL) matrix, element r(i,j)= tranition rate from i to j 
% LMBD a a L dimansional vector giving the rates for each phase.
% m the message length of  messages.

function [Pof1,P1pe,P2pe] = ex88(R,LMBD,m)

%We get D0 and D1 from example 8.1.
fetch = ex81(R,LMBD);
D0=fetch(:,:,1);
D1=fetch(:,:,2);
D = D0 + D1; 
 I = [ 1 0; 0 1];
L=size(R,1);
ms = m; 
%Initialization
theta = max(max(-D0));
gamma0 = exp(-theta*m);
L0 = [I zeros(2,2) zeros(2,2) zeros(2,2)];
S = [ D D1 zeros(2,2) zeros(2,2); zeros(2,2) D (2*D1) zeros(2,2);zeros(2,2) zeros(2,2) D (3*D1)];
S = [S;zeros(2,2) zeros(2,2) zeros(2,2) D];
inter1 = (eye(8,8) + (theta^(-1)*S));
EL(:,:,1) = L0*inter1;
gamma(1)  = gamma0*(theta * m); 
tempmat = (gamma0*L0)+(gamma(1)*EL(:,:,1));
gammasum = gamma0+gamma(1);
et = [1;1];
epsilon1 = 10^(-16);

for i = 2: 2000
     EL(:,:,i) =    EL(:,:,(i-1))*inter1;
     gamma(i) = gamma(i-1)*theta*m/i;
     tempmat = tempmat + (gamma(i)*EL(:,:,i));
     gammasum=gammasum+gamma(i);
     if (  (abs(1-max(tempmat(:,1:2)*et))<epsilon1) & (gammasum > (1-epsilon1)) )
        count = i;
        break;
     end
end 

% we get from the above iteration A, Aprime, Adoubleprime and Atriple prime...
A = tempmat(:,1:2)
A1p = tempmat(:,3:4);
A2p = tempmat(:,5:6);
A3p = tempmat(:,7:8);

[P0 pi alphaint G] =ex86(R,LMBD,m);
avelmbd=pi*D1*ones(L,1);
rho=avelmbd*m;

% Now, here we are getting Uprime, Udouble prime and Utriple prime...
temp1 =  -P0*D0^(-1);
U1p = temp1*((D1*A)+(D*A1p));
U2p = temp1*((2*D1*A1p)+(D*A2p));
U3p = temp1*((3*D1*A2p)+(D*A3p));

temp2 = (I-A+(et*pi))^(-1); 
P1 = pi + (temp1*D*A*temp2);

P1p  = (1/(2*(1-rho)))*(     (P1*A2p)   + U2p + (  2* ( U1p-(P1*(I-A1p)) )*temp2*alphaint  )     );
P2p  = (1/(3*(1-rho)))*(    (3*P1p*A2p)+(P1*A3p)+U3p + (  3*( U2p+(P1*A2p)-(2*P1p*(I-A1p)) )*temp2*alphaint  )   );

%P1pchk = [0 0];

%for i = 1:nr
%   P1pchk = P1pchk + (i*p((i-1)*2+1:i*2));
%end
    
P1pe = P1p*et;
P2pe = P2p*et;
Pof1 = P1;
chk = P0
return
