%In this example, we are evaluting Equations (8.76) and (8.77) 
%The inputs are: 
% R a (LxL) matrix, element r(i,j)= tranition rate from i to j 
% LMBD a a L dimansional vector giving the rates for each phase.
% m the message length of  messages.

function [P0hat,P1hat,P2hat] = ex89(R,LMBD,m)

%We get D0 and D1 from example 8.1.
fetch = ex81(R,LMBD);
D0=fetch(:,:,1);
D1=fetch(:,:,2);
D = D0 + D1; 
 I = [ 1 0; 0 1];
L=size(R,1);
ms = m; 
[P0 pi alphaint G] =ex86(R,LMBD,m);
avelmbd=pi*D1*ones(L,1);
rho=avelmbd*m;
[P0 P1 P2 p] = ex87m(R,LMBD,m,m);
   
P0hat = -avelmbd*P0*D0^(-1);
Phat(1:2) = ((P0hat*D1) - (avelmbd*(P0-p(1:2))))*(-D0^(-1));
nr = length(p)/2;
for i = 2:nr
    Phat((i-1)*2+1:i*2) = ( (Phat((i-2)*2+1:(i-1)*2)*D1) - ( avelmbd*( p((i-2)*2+1:(i-1)*2) - p((i-1)*2+1:i*2) ) ) ) *(-D0^(-1));
end

P1hat = Phat(1:2);
P2hat = Phat(3:4);
P3hat = Phat(5:6);
P4hat = Phat(7:8);
P5hat = Phat(9:10);

return

