function [phi, d, a] = phievaluate(n,d,beta,dstar)
% A function which evaluates phi vector corresponding to d SPP's.
d0 = 0;
for i = 1:d-1
    phi(i) = 0;
end
phi(d) = 1;
a = 10^(n/(d-1));
for i = 1:d-1
   Dt = a^(i*beta);
   for j = 0:i-1
       Dt = Dt - (phi(d-j)^2*exp(1 - a^(-(i-j))));
   end
    if (Dt < 0)
       phi(d-i) = 0;
       d0 = d0 + 1;
        if dstar > (d - d0)
             d = 0;
             break;
        end
   else
        phi(d-i) = sqrt(Dt);
   end
end
