%The program for generating a probability histogram 
%for a geometric distribution by calculating the time 
%until the first success.The inputs are the 
%the probability of success on  a trial
%and smplsz which is the number of samples.

function [h]= ex913geo(p,smplsz)

max=fix((1-p)/p)+10*(fix((1-p)/p^2)+1)
%initializing the maximum value of the sample
h=zeros(1,max);%initiallizing the histogram at max length


%Now generate samples from the geometric distribution 
%and compile the histogram. 
for i=1:smplsz  
   
   ind=0;%initializing       
   while rand>p & ind+1<max %stepping through the distribution
      ind=ind+1;
   end
   
   %ind is the value of the sample
   h(ind+1)=h(ind+1)+1;%compiling the histogram
end 

for i=1:max
   h(i)=h(i)/smplsz;%Normalizing the histogram
end

